<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Try Catch Homework</title>
</head>
<body>
    <div id="root"></div>
    <script>
    const books = [
        { 
            author: "Скотт Бэккер",
            name: "Тьма, что приходит прежде",
            price: 70 
        }, 
        {
            author: "Скотт Бэккер",
            name: "Воин-пророк",
        }, 
        { 
            name: "Тысячекратная мысль",
            price: 70
        }, 
        { 
            author: "Скотт Бэккер",
            name: "Нечестивый Консульт",
            price: 70
        }, 
        {
            author: "Дарья Донцова",
            name: "Детектив на диете",
            price: 40
        },
        {
            author: "Дарья Донцова",
            name: "Дед Снегур и Морозочка",
        }
    ];
      
        let id = document.getElementById('root');
            function showList(arr){
                let elem = arr.map((obj) => {
                    const {author, name, price} = obj;
                 try {
                    if(author && name && price) {
                       return `
                        <li>Author: ${author}</li>
                        <li>Name: ${name}</li>
                        <li>Price: ${price}</li>
                        `
                    }
                else if (!author) {
                    throw new Error('Ошибка. Не заполнено поле author.')
                } else
                if (!name) {
                    throw new Error('Ошибка. Не заполнено поле name.')
                } else
                if (!price) {
                    throw new Error('Ошибка. Не заполнено поле price.')
                }
            }  catch(e) {
                console.error(e);
            } 
                    
                })
                id.innerHTML = `<ul>${elem.join(`<br>`)}</ul>`;
                }
                showList(books)
            // try{
            //     showList(books);
            // } catch(e){
            //     console.log(e);
            // }
    </script>
</body>
</html>